-- Conversion routines to convert the weird SFML keycode enumeration to ASCII

-- Table to map a digit to an uppercase symbol
sf.numtable={}
sf.numtable[sf.Key.Num0]={48,41}
sf.numtable[sf.Key.Num1]={49,33}
sf.numtable[sf.Key.Num2]={50,64}
sf.numtable[sf.Key.Num3]={51,35}
sf.numtable[sf.Key.Num4]={52,36}
sf.numtable[sf.Key.Num5]={53,37}
sf.numtable[sf.Key.Num6]={54,94}
sf.numtable[sf.Key.Num7]={55,38}
sf.numtable[sf.Key.Num8]={56,42}
sf.numtable[sf.Key.Num9]={57,40}
	

-- Table to map SFML punctuation to ASCII punct.

sf.punctable={}
sf.punctable[sf.Key.LBracket]={91, 123}
sf.punctable[sf.Key.RBracket]={93, 125}
sf.punctable[sf.Key.SemiColon]={59, 58}
sf.punctable[sf.Key.Comma]={44, 60}
sf.punctable[sf.Key.Period]={46, 62}
sf.punctable[sf.Key.Quote]={39, 34}
sf.punctable[sf.Key.Slash]={47, 63}
sf.punctable[sf.Key.BackSlash]={92, 124}
sf.punctable[sf.Key.Tilde]={96, 126}
sf.punctable[sf.Key.Equal]={61,43}
sf.punctable[sf.Key.Dash]={45, 95}
sf.punctable[sf.Key.Space]={32, 32}
sf.punctable[sf.Key.Return]={13, 13}

function SFMLKeyToASCII(key, shift)
	if(key>=sf.Key.Num0 and key<=sf.Key.Num9) then
		if shift then return sf.numtable[key][2] else return sf.numtable[key][1] end
	elseif key>=sf.Key.A and key<=sf.Key.Z then
		if shift then return tonumber(key)-32 else return tonumber(key) end
	elseif key>=sf.Key.LBracket and key<=sf.Key.Return then
		if shift then return sf.punctable[key][2] else return sf.punctable[key][1] end
	else
		return key
	end
end
