require 'gui_base'

GUI_BUTTON_ACTIVE = 1
GUI_BUTTON_HOVER = 2
GUI_BUTTON_CLICKED=3
GUI_BUTTON_GREYED =4

GUIButton=class(GUIBase, function(c,x,y,w,h,name)
	GUIBase.init(c,x,y,w,h)
	c.active=true
	c.clicked=false
	c:setButtonState(1)
	c.sprite=CSpriteGrid(name,4,1)
	end)
	
function GUIButton:doClick()
	if self.clickfunction==nil then return end
	if self.clickobject==nil then self.clickfunction() return end
	self.clickfunction(self.clickobject)
end
	
function GUIButton:setButtonState(state)
	if state<1 or state >4 then self.row=0 self.col=0 return end
	self.buttonstate=state
	self.col=0
	self.row=self.buttonstate-1
end

function GUIButton:setOnClick(clickfunction, clickobject)
	self.clickfunction=clickfunction
	self.clickobject=clickobject
end

function GUIButton:setActiveState(active)
	if active==true then
		self.active=true
		self:setButtonState(1)
	else
		self.active=false
		self:setButtonState(4)
	end
end

function GUIButton:drawSelf(t)
	local sx,sy=self:getScreenLocation()
	if self.sprite then self.sprite:render(sx,sy,self.w,self.h,self.row,self.col) end
end
	


function GUIButton:handleEventSelf(se)
	if self.active==false then self:setButtonState(4) return false end
	
	if se.Type==se.MouseMoved then
		-- Test to see if the mouse is on the button
		if self:checkPoint(se.MouseMove.X, se.MouseMove.Y) then
			-- If clicked, set state to clicked, else set state to hover
			--console_print("Mouse moved onto button")
			if self.clicked then self:setButtonState(3)
			else self:setButtonState(2)
			end
		else
			-- Not on the button, clear clicked and set to ready state
			self.clicked=false
			self:setButtonState(1)
			return false
		end
		return false -- No "handled" notification for mouse moves
	elseif se.Type==se.MouseButtonPressed and se.MouseButton.Button==sf.Mouse.Left then
		if self:checkPoint(se.MouseButton.X, se.MouseButton.Y) then
			self.clicked=true
			self:setButtonState(3)
			--print("buttont down")
			return true
		else
			return false
		end
		
	elseif se.Type==se.MouseButtonReleased and se.MouseButton.Button==sf.Mouse.Left then
		if self:checkPoint(se.MouseButton.X, se.MouseButton.Y) then
			if self.clicked==true then
				self.clicked=false
				self:doClick()
				self:setButtonState(2)
				return true
			else
				return false
			end
		else
			return false
		end
	end
	return false
end

