-- Implement a hotkey handling table that maps hotkeys to actions. Attach this to a GUI object

require 'class'

HotkeyActionTable=class(function(a) a.keytable={} end)

function HotkeyActionTable:insertMapping(key, func, func_obj)
	self.keytable[key]={key_func=func, key_obj=func_obj}
end

function HotkeyActionTable:removeMapping(key)
	self.keytable[key]=nil
end

function HotkeyActionTable:fireKey(key)
	if self.keytable[key]~=nil then
		if self.keytable[key].key_func==nil then return false end
		if self.keytable[key].key_obj==nil then return self.keytable[key].key_func() end
		return self.keytable[key].key_func(self.keytable[key].key_obj)
	end
	return false
end
