-- Level Viewer Component
-- Implement a simple class to just move around the leve, similar to the old TestPlayerControlComponent

LevelViewerComponent=class(function(a)
	a.logical_pos={0,0,0}
	a.vis_pos={0,0,0}
	a.speed=0.08
	a.facing_x=0
	a.facing_z=1
	a.moving=false
	end)
	
function LevelViewerComponent:UpdateLogic(owner,args)
	if self.moving==false then
		owner:handleMessage("UpdateObjectLogicalPositionFix")
		return
	else
		local mx,my=0,0
		mx,my=core_system:getMouseCoords(mx,my)
		local vec=world:reverseProjectOnPlane(mx,my,0)
		self:SetFacingVector(vec.x, vec.z)
		
		local curpos={x=self.logical_pos[1], y=self.logical_pos[2], z=self.logical_pos[3]}
		curpos.x=curpos.x+self.facing_x*self.speed
		curpos.z=curpos.z+self.facing_z*self.speed
		owner:handleMessage("UpdateObjectLogicalPosition", curpos)
	end
end

function LevelViewerComponent:SetObjectLogicalPosition(owner, args)
	self.logical_pos={args.x, args.y, args.z}
end

function LevelViewerComponent:UpdateObjectLogicalPosition(owner,args)
	self.logical_pos={args.x, args.y, args.z}
end

function LevelViewerComponent:SetFacingVector(mouse_x, mouse_y)
	local curvis={x=self.logical_pos[1], y=self.logical_pos[2], z=self.logical_pos[3]}
	self.facing_x=mouse_x-curvis.x
	self.facing_z=mouse_y-curvis.z
	local len=math.sqrt(self.facing_x*self.facing_x + self.facing_z*self.facing_z)
	self.facing_x=self.facing_x/len
	self.facing_z=self.facing_z/len
end

function LevelViewerComponent:LMBDown(owner,args)
	self:SetFacingVector(args.mouse_x, args.mouse_y)
	self.moving=true
end

function LevelViewerComponent:LMBUp(owner,args)
	self.moving=false
end

function LevelViewerComponent:UpdateObjectVisualPosition(owner, args)
	world:setCameraCenter(args.x, args.z)
	if mapmarker~=nil then
		local px=args.x / world.worldsize
		local py=args.z / world.worldsize
		
		-- Interp p1->p3 and p2->p4 on py
		local nx1=mm1_x+py*(mm3_x-mm1_x)
		local ny1=mm1_y+py*(mm3_y-mm1_y)
		
		local nx2=mm2_x+py*(mm4_x-mm2_x)
		local ny2=mm2_y+py*(mm4_y-mm2_y)
		
		-- Interp on px
		local nx3=nx1+px*(nx2-nx1)
		local ny3=ny1+px*(ny2-ny1)
		
		-- subtract 4 for the center of the marker
		nx3=nx3-4
		ny3=ny3-4
		
		mapmarker:setPosition(nx3, ny3)
		--print("Map marker: "..nx3..","..ny3)
	end
end
